<?php
/**
 * Functions area.
 * @copyright	Copyright (C) 2010 AllFreeCMS dot com. 
 * This theme created based on Grid960CSS 12 columns - thanks to 960 Grid System ~ 
 * Core CSS for great framework. (Learn more ~ http://960.gs/)
 * Any questions? Do not hesitate to contact me : http://allfreecms.com/contact/
 * @package AFC_Mataram_106
 * @subpackage functions - there're a lot of kind will be here
 */
/**
 * Set the content width based on the theme's design and stylesheet.
 *
 * Used to set the width of images and content. Should be equal to the width the theme
 * is designed for, generally via the style.css stylesheet.
 */
if ( ! isset( $content_width ) )
	$content_width = 464;

add_action( 'after_setup_theme', 'afc_setup' );
function afc_setup() {
add_theme_support( 'automatic-feed-links' );
	register_nav_menus( array(
		'smoothClean' => __( 'smoothClean Navigation'),		
	) ); 
	
add_theme_support( 'post-thumbnails' );
add_custom_background() ;
add_editor_style();
}

 function the_breadcrumb() { 
	echo '<a  rel="bookmark" href="'; echo home_url(); 
	echo '/">'; bloginfo('name'); echo "</a> &raquo; "; 
if (is_single()) {  the_title(); }
if (is_page()) { echo the_title();} 
if (is_category()) { single_cat_title();}
if (is_tag()) { single_tag_title();}
if (is_author()) {echo "Author Archive";}
if (isset($_GET['paged']) && !empty($_GET['paged'])) {echo "Blog Archives";}
if (is_search()) {echo "Search Results";}
} 

function page_menu_args( $args ) {
	$args['show_home'] = true;
	return $args;
}
add_filter( 'wp_page_menu_args', 'page_menu_args' );

 function afc_excerpt_length($length) {
	return 90;
}
add_filter('excerpt_length', 'afc_excerpt_length');
 
function continue_reading_link() {
	return ' <span class="read-more"><a href="'. get_permalink() . '">' . __( 'Read More...') . '</a></span>';
}

function afc_excerpt_more( $more ) {
	return ' &hellip;' . continue_reading_link();
}
add_filter( 'excerpt_more', 'afc_excerpt_more' );

function limit_title($title, $n){
if ( strlen ($title) > $n )
{
echo substr(the_title($before = "", $after = "", FALSE), 0, $n) . '...';
}
else { the_title(); }
}

function getImage($num) {
global $more;
$more = 1;
$content = get_the_content();
$count = substr_count($content, '<img');
$start = 0;
for($i=1;$i<=$count;$i++) {
$imgBeg = strpos($content, '<img', $start);
$post = substr($content, $imgBeg);
$imgEnd = strpos($post, '>');
$postOutput = substr($post, 0, $imgEnd+1);
$image[$i] = $postOutput;
$start=$imgEnd+1;

$cleanF = strpos($image[$num],'src="')+5;
$cleanB = strpos($image[$num],'"',$cleanF)-$cleanF;
$imgThumb = substr($image[$num],$cleanF,$cleanB);

}
if(stristr($image[$num],'<img')) { echo $imgThumb; }
else {echo get_template_directory_uri() ."/images/afcnoimage.png";} 
$more = 0;
}

function custom_excerpt_more( $output ) {
	if ( has_excerpt() && ! is_attachment() ) {
		$output .= continue_reading_link();
	}
	return $output;
} 
add_filter( 'get_the_excerpt', 'custom_excerpt_more' );

if ( ! function_exists( 'afc_comment' ) ) :
function afc_comment( $comment, $args, $depth ) {
	$GLOBALS['comment'] = $comment;
	switch ( $comment->comment_type ) :
		case '' :
	?>
	<li <?php comment_class(); ?> id="li-comment-<?php comment_ID(); ?>">
		<div id="comment-<?php comment_ID(); ?>">
		<div class="comment-author vcard">
			<?php echo get_avatar( $comment, 40 ); ?>
			<?php printf( __( '%s <span class="says">says:</span>' ), sprintf( '<cite class="fn">%s</cite>', get_comment_author_link() ) ); ?>
		</div>
		<?php if ( $comment->comment_approved == '0' ) : ?>
			<em><?php _e( 'Your comment is awaiting moderation.' ); ?></em>
			<br />
		<?php endif; ?>

		<div class="comment-meta commentmetadata"><a href="<?php echo esc_url( get_comment_link( $comment->comment_ID ) ); ?>">
			<?php printf( __( '%1$s at %2$s' ), get_comment_date(),  get_comment_time() ); ?></a><?php edit_comment_link( __( '(Edit)' ), ' ' );
			?>
		</div>

		<div class="comment-body"><?php comment_text(); ?></div>

		<div class="reply">
			<?php comment_reply_link( array_merge( $args, array( 'depth' => $depth, 'max_depth' => $args['max_depth'] ) ) ); ?>
		</div>
	</div>

	<?php
			break;
		case 'pingback'  :
		case 'trackback' :
	?>
	<li class="post pingback">
		<p><?php _e( 'Pingback:' ); ?> <?php comment_author_link(); ?><?php edit_comment_link( __('(Edit)'), ' ' ); ?></p>
	<?php
			break;
	endswitch;
}
endif;

function afc_posted_date (){
printf ( the_time('F jS, Y') );
}

function afc_posted_in_catsonly () {
if ( count( get_the_category() ) ) :?>
<span class="cat-links">
<?php printf ( get_the_category_list( ', ' ) );?>
</span>
<?php endif; }

function afc_posted_tags () {
$tags_list = get_the_tag_list( '', ', ' );
if ( $tags_list ):
?>
<span class="tag-links">
<?php printf( $tags_list ); ?>
</span>			
<?php endif;
}

add_filter( 'the_password_form', 'custom_password_form' );
function custom_password_form() {
	global $wp_query;
	$page_id = $wp_query->post->ID;
	$custom_excerpt = get_page( $page_id );
	$custom_output = '<div id="teaser"><p>' . $custom_excerpt->post_excerpt . '</p></div>' . "\r\n";

	global $post;
	$label = 'pwbox-'.( empty( $post->ID ) ? rand() : $post->ID );
	$o = '<form class="protected-post-form" action="' . get_option('siteurl') . '/wp-pass.php" method="post">
	' . __( "This post is password protected. To view it please enter your password below:" ) . '
	<label for="' . $label . '">' . __( "Password:" ) . ' </label><input name="post_password" id="' . $label . '" type="password" size="20" /><input type="submit" name="Submit" value="' . esc_attr__( "Submit" ) . '" />
	</form>
	';
	return $o;
}

function afcget_search_form($form) {
$form = '<form method="get" id="searchform" action="' . home_url() . '/" >
<div>

<label class="screen-reader-text" for="s">' . __('Search for:') . '</label>
<input type="text" value="' . esc_attr(apply_filters('the_search_query', get_search_query())) . '" name="s" id="s" />
<input type="submit" id="searchsubmit" value="'.esc_attr(__('Search')).'" />
</div>
</form>';
return $form;
}
add_filter('get_search_form', 'afcget_search_form'); 
 
 //------------//
 
function afc_remove_recent_comments_style() {
	global $wp_widget_factory;
	remove_action( 'wp_head', array( $wp_widget_factory->widgets['WP_Widget_Recent_Comments'], 'recent_comments_style' ) );
}
add_action( 'widgets_init', 'afc_remove_recent_comments_style' );

function mytheme_comment($comment, $args, $depth) {
   $GLOBALS['comment'] = $comment; ?>
   <li <?php comment_class(); ?> id="li-comment-<?php comment_ID() ?>">
     <div id="comment-<?php comment_ID(); ?>">
      <div class="comment-author vcard">
         <?php echo get_avatar($comment,$size='48',$default='<path_to_url>' ); ?>

         <?php printf(__('<cite class="fn">%s</cite> <span class="says">says:</span>'), get_comment_author_link()) ?>
      </div>
      <?php if ($comment->comment_approved == '0') : ?>
         <em><?php _e('Your comment is awaiting moderation.') ?></em>
         <br />
      <?php endif; ?>

      <div class="comment-meta commentmetadata"><a href="<?php echo htmlspecialchars( get_comment_link( $comment->comment_ID ) ) ?>"><?php printf(__('%1$s at %2$s'), get_comment_date(),  get_comment_time()) ?></a><?php edit_comment_link(__('(Edit)'),'  ','') ?></div>

      <?php comment_text() ?>

      <div class="reply">
         <?php comment_reply_link(array_merge( $args, array('depth' => $depth, 'max_depth' => $args['max_depth']))) ?>
      </div>
     </div>
<?php
        }
//removed style gallery
		add_filter('gallery_style',
	create_function(
		'$css',
		'return preg_replace("#<style type=\'text/css\'>(.*?)</style>#s", "", $css);'
		)
	);

function my_custom_dashboard_widgets() {
global $wp_meta_boxes;wp_add_dashboard_widget('custom_help_widget', 'AFC Theme Support', 'custom_dashboard_help');
}
add_action('wp_dashboard_setup', 'my_custom_dashboard_widgets');

function afc_widgets_init() {
 	
	register_sidebar( array(
		'name' => __( 'Mataram Default Widget' ),
		'id' => 'smc-def-widget',
		'description' => __( 'Widget for Default - Right Side' ),
		'before_widget' => '<div class="afcget">',
		'after_widget' => '</div>',
		'before_title' => '<h3 class="afcget-title">',
		'after_title' => '</h3>',
	) );	 

	
	register_sidebar( array(
		'name' => __( 'Mataram More Widget' ),
		'id' => 'smc-more-widget',
		'description' => __( 'WantMore widget area - center' ),
		'before_widget' => '<div class="afcget">',
		'after_widget' => '</div>',
		'before_title' => '<h3 class="afcget-title">',
		'after_title' => '</h3>',
	) );

	register_sidebar( array(
		'name' => __( 'Mataram First Footer Widget' ),
		'id' => 'smc-footone-widget',
		'description' => __( 'The first footer widget area' ),
		'before_widget' => '<div class="afcgetfoot">',
		'after_widget' => '</div>',
		'before_title' => '<h3 class="afcget-title">',
		'after_title' => '</h3>',
	) );

	register_sidebar( array(
		'name' => __( 'Mataram Second Footer Widget' ),
		'id' => 'smc-foottwo-widget',
		'description' => __( 'The second footer widget area' ),
		'before_widget' => '<div class="afcgetfoot">',
		'after_widget' => '</div>',
		'before_title' => '<h3 class="afcget-title">',
		'after_title' => '</h3>',
	) );

	register_sidebar( array(
		'name' => __( 'Mataram Third Footer Widget' ),
		'id' => 'smc-footthree-widget',
		'description' => __( 'The third footer widget area' ),
		'before_widget' => '<div class="afcgetfoot">',
		'after_widget' => '</div>',
		'before_title' => '<h3 class="afcget-title">',
		'after_title' => '</h3>',
	) );
	
	register_sidebar( array(
		'name' => __( 'Mataram Fourth Footer Widget' ),
		'id' => 'smc-footfour-widget',
		'description' => __( 'The fourth footer widget area' ),
		'before_widget' => '<div class="afcgetfoot">',
		'after_widget' => '</div>',
		'before_title' => '<h3 class="afcget-title">',
		'after_title' => '</h3>',
	) );

}
add_action( 'widgets_init','afc_widgets_init' );

function custom_dashboard_help() {
echo '<p>Welcome to AllFreeCMS Free Custom Wordpress Theme! Need help? Want to Donate to get more free Custom WordPress Theme, <a href="https://www.paypal.com/cgi-bin/webscr?cmd=_donations&business=myfia%40riesurya%2ecom&lc=US&item_name=AllFreeCMS&currency_code=USD&bn=PP%2dDonationsBF%3abtn_donate_LG%2egif%3aNonHosted"> Donations</a>. </p>';
}

$themename = "AFC Mataram ";
$themedownloadurl = "http://allfreecms.com/";
$shortname = "afcmtr";

$options = array (
 
array( "name" => $themename." Options",
	"type" => "title"),
	
array( "name" => "General",
	"type" => "section"),
array( "type" => "open"),
	
array( "name" => "Site Slogan",
	"desc" => "Enter site slogan text here",
	"id" => $shortname."_getslogan",
	"type" => "text",
	"std" => get_bloginfo( 'title' )),

array( "name" => "Color Scheme",
	"desc" => "Select the color scheme for the theme",
	"id" => $shortname."color",
	"type" => "select",
	"options" => array("orange-and-blue", "green","blue"),
	"std" => "orange-and-blue"),

array( "name" => "Sticky Post on Homepage Display",
	"desc" => "Option to display sticky post (is any) on homepage",
	"id" => $shortname."stickyyes",
	"type" => "select",
	"options" => array("Yes", "No"),
	"std" => "Yes"),
	
array( "type" => "close"),

array( "name" => "Homepage Thumbnail",
	"type" => "section"),
array( "type" => "open"),

array( "name" => "Homepage Thumbnail Display",
	"desc" => "Display auto generated thumbnail on homepage",
	"id" => $shortname."thumb",
	"type" => "select",
	"options" => array("No", "Yes"),
	"std" => "No"),
	
array( "type" => "close"),
	
	
array( "name" => "FeedBurner RSS Setting",
	"type" => "section"),
array( "type" => "open"),

array( "name" => "Feedburner RSS Options",
	"desc" => "Display feedburner RSS?",
	"id" => $shortname."feedyes",
	"type" => "select",
	"options" => array("Yes", "No"),
	"std" => "Yes"),
	
array( "name" => "Feedburner URL",
	"desc" => "Type Feedburner ID (example AllFreeCMS) here, otherwise it will displayed default WordPress RSS Feed as link",
	"id" => $shortname."_getfeed",
	"type" => "text",
	"std" => ''),	
	
array( "type" => "close"),
	
array( "name" => "Youtube Video Option Setting",
	"type" => "section"),
array( "type" => "open"),

array( "name" => "Youtube Video Options",
	"desc" => "Display youtube video below Feedburner RSS?",
	"id" => $shortname."videoyes",
	"type" => "select",
	"options" => array("No", "Yes"),
	"std" => "No"),
	
array( "name" => "Youtube Video code",
	"desc" => "Type Youtube Video code here, otherwise it will displaying demo video - <strong>homepage only</strong>",
	"id" => $shortname."getvideo",
	"type" => "text",
	"std" => ""),
	
array( "name" => "Video Title",
	"desc" => "Type Video title here, otherwise it will displaying Featured Video",
	"id" => $shortname."videotitle",
	"type" => "text",
	"std" => "Featured Video"),
		
array( "type" => "close"),

array( "name" => "Heading Options",
	"type" => "section"),
array( "type" => "open"),

array( "name" => "Custom Header Information",
	"desc" => "Custom Header Info, like addon meta information ",
	"id" => $shortname."metaoption",
	"type" => "textarea",
	"std" => ""),
	
array( "type" => "close"),

array( "name" => "Advertising Options",
	"type" => "section"),
array( "type" => "open"),

array( "name" => "Advertising 468px option",
	"desc" => "Display Advertising 468px on top of page?",
	"id" => $shortname."gettopadsyes",
	"type" => "select",
	"options" => array("No", "Yes"),
	"std" => "No"),
	
array( "name" => "Advertising Code for top of page - 468px",
	"desc" => "Insert Advertising Code, like Google Ads or others ads",
	"id" => $shortname."gettopads",
	"type" => "textarea",
	"std" => ""),	

array( "name" => "Advertising for homepage option",
	"desc" => "Display option for advertising on homepage",
	"id" => $shortname."adshomeyes",
	"type" => "select",
	"options" => array("No", "Yes"),
	"std" => "No"),
	
array( "name" => "Advertising Code for homepage",
	"desc" => "Insert Advertising Code, like Google Ads or others ads ",
	"id" => $shortname."getadshome",
	"type" => "textarea",
	"std" => ""),	
	
array( "name" => "Advertising for single, category etc option",
	"desc" => "Display option for advertising on single page, category, archives, tags, and pages",
	"id" => $shortname."adspostyesno",
	"type" => "select",
	"options" => array("No", "Yes"),
	"std" => "No"),
	
array( "name" => "Advertising Code for single page, category, archives, tags, and pages",
	"desc" => "Insert Advertising Code, like Google Ads or others ads ",
	"id" => $shortname."getadspost",
	"type" => "textarea",
	"std" => ""),	

array( "name" => "Advertising Unit Link - 468px option",
	"desc" => "Display option for advertising 468px as Unit Link ",
	"id" => $shortname."unitadsyesno",
	"type" => "select",
	"options" => array("No", "Yes"),
	"std" => "No"),
	
array( "name" => "Advertising Unit Link Code - 468px",
	"desc" => "Insert Unit Link Advertising Code, like Google Ads or others ads ",
	"id" => $shortname."getunitads",
	"type" => "textarea",
	"std" => ""),	
	
array( "type" => "close"),

array( "name" => "Footer",
	"type" => "section"),
array( "type" => "open"),
	
array( "name" => "Footer Code",
	"desc" => "You can paste your Google Analytics or other tracking code in this box. This will be automatically added to the footer.",
	"id" => $shortname."getfoot_code",
	"type" => "textarea",
	"std" => ""),	
array( "type" => "close")
);


function mytheme_add_admin() {
global $themename, $shortname, $options;
if ( isset ($_GET['page']) ) 
if ( isset ($_REQUEST['action'] ))
if ( $_GET['page'] == basename(__FILE__) ) {
if ( 'save' == ($_REQUEST['action'] )) {
foreach ($options as $value) {
update_option( $value['id'], $_REQUEST[ $value['id'] ] ); }

foreach ($options as $value) {
if( isset( $_REQUEST[ $value['id'] ] ) ) { 
update_option( $value['id'], $_REQUEST[ $value['id'] ]  ); 
} else { 
delete_option( $value['id'] ); } 
}
header("Location: admin.php?page=functions.php&saved=true");
die;} 

else 
if( 'reset' ==($_REQUEST['action'] )) {
foreach ($options as $value) {
delete_option( $value['id'] ); }
header("Location: admin.php?page=functions.php&reset=true");
die;
}}
add_menu_page($themename, $themename, 'administrator', basename(__FILE__), 'mytheme_admin');
}
function mytheme_add_init() {
$file_dir = get_template_directory_uri();
wp_enqueue_style("functions", $file_dir."/functions/functions.css", false, "1.0", "all");
wp_enqueue_script("rm_script", $file_dir."/functions/rm_script.js", false, "1.0");
}

function mytheme_admin() {
global $themename, $shortname, $options;
$i=0;
if (isset ($_REQUEST['saved'] )) echo '<div id="message" class="updated fade"><p><strong>'.$themename.' settings saved.</strong></p></div>';
if (isset( $_REQUEST['reset'] )) echo '<div id="message" class="updated fade"><p><strong>'.$themename.' settings reset.</strong></p></div>';
?>

<div class="wrap rm_wrap">
<h2><?php echo $themename; ?> Settings</h2>
<div class="rm_opts">
<form method="post">
<?php foreach ($options as $value) {
switch ( $value['type'] ) { case "open": break; case "close":?>
</div>
</div>
<br />
<?php break; case "title":?>
<p>Thanks for using <?php echo $themename;?>, below some options that may help you to use the power of WordPress Theme I have made. Don't miss other themes for free from All Free CMS theme Collections with <a href="http://allfreecms.com/feed/">Feed subscribing</a> and if you happy with this theme and want to support me to make more and more free theme, you can do make <a href="https://www.paypal.com/cgi-bin/webscr?cmd=_donations&business=myfia%40riesurya%2ecom&lc=US&item_name=AllFreeCMS&currency_code=USD&bn=PP%2dDonationsBF%3abtn_donate_LG%2egif%3aNonHosted">some donations</a> and or <a href="http://allfreecms.com/advertise/">join as sponsors</a> for the next <strong>more featured</strong> theme.</p>
<p>Get the latest version of this theme from <a href="http://allfreecms.com/mataram-wordpress-theme/"><?php echo$themename;?> </a></p>
<?php break; case 'text':?>
<div class="rm_input rm_text">
<label for="<?php echo $value['id']; ?>"><?php echo $value['name']; ?></label>
<input name="<?php echo $value['id']; ?>" id="<?php echo $value['id']; ?>" type="<?php echo $value['type']; ?>" value="<?php if ( get_option( $value['id'] ) != "") { echo stripslashes(get_option( $value['id'])  ); } else { echo $value['std']; } ?>" />
<small><?php echo $value['desc']; ?></small><div class="clearfix"></div>
</div>
<?php break; case 'textarea':?>
<div class="rm_input rm_textarea">
<label for="<?php echo $value['id']; ?>"><?php echo $value['name']; ?></label>
<textarea name="<?php echo $value['id']; ?>" type="<?php echo $value['type']; ?>" cols="" rows=""><?php if ( get_option( $value['id'] ) != "") { echo stripslashes(get_option( $value['id']) ); } else { echo $value['std']; } ?></textarea>
<small><?php echo $value['desc']; ?></small><div class="clearfix"></div>
</div>
<?php break;case 'select':?>
<div class="rm_input rm_select">
<label for="<?php echo $value['id']; ?>"><?php echo $value['name']; ?></label>
<select name="<?php echo $value['id']; ?>" id="<?php echo $value['id']; ?>">
<?php foreach ($value['options'] as $option) { ?>
<option <?php if (get_option( $value['id'] ) == $option) { echo 'selected="selected"'; } ?>><?php echo $option; ?></option><?php } ?>
</select>
<small><?php echo $value['desc']; ?></small><div class="clearfix"></div>
</div>
<?php break; case "checkbox":?>
<div class="rm_input rm_checkbox">
<label for="<?php echo $value['id']; ?>"><?php echo $value['name']; ?></label>
<?php if(get_option($value['id'])){ $checked = "checked=\"checked\""; }else{ $checked = "";} ?>
<input type="checkbox" name="<?php echo $value['id']; ?>" id="<?php echo $value['id']; ?>" value="true" <?php echo $checked; ?> />
<small><?php echo $value['desc']; ?></small><div class="clearfix"></div>
</div>
<?php break; 
case "section":
$i++;
?>
<div class="rm_section">
<div class="rm_title"><h3><img src="<?php echo get_template_directory_uri();?>/functions/images/trans.png" class="inactive" alt="""><?php echo $value['name']; ?></h3><span class="submit"><input name="save<?php echo $i; ?>" type="submit" value="Save changes" />
</span><div class="clearfix"></div></div>
<div class="rm_options">
<?php break;
}
}
?>
<input type="hidden" name="action" value="save" />
</form>
<form method="post">
<p class="submit">
<input name="reset" type="submit" value="Reset" />
<input type="hidden" name="action" value="reset" />
</p>
</form>
<div style="font-size:9px; margin-bottom:10px;">Theme present by : <a href="http://allfreecms.com/">All Free CMS</a></div>
 </div> 
<?php
}
?>
<?php
add_action('admin_init', 'mytheme_add_init');
add_action('admin_menu', 'mytheme_add_admin');
?>